=== debian/changelog ===
deepin-installer-reborn (5.7.43-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 12 Aug 2022 19:25:35 +0800
