=== debian/changelog ===
deepin-installer-reborn (5.7.47-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 20 Sep 2022 18:10:01 +0800
