=== debian/control ===
Source: deepin-installer-reborn
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
    cmake (>=3.1),
    debhelper (>=9),
    dh-systemd,
    g++ (>=6.3.0),
    gettext,
    tzdata,
    deepin-installer-timezones,
    libattr1-dev,
    libparted-dev,
    libqt5x11extras5-dev,
    libx11-dev,
    libxext-dev,
    libxrandr-dev,
    libxss-dev,
    libxtst-dev,
    pkg-config,
    qtbase5-dev,
    qttools5-dev,
    qttools5-dev-tools,
    zlib1g-dev,
    libqt5svg5-dev,
    libdtkcore-dev,
    libdtkcore5-bin | libdtkcore-bin,
    libudisks2-qt5-dev,
    libqapt-dev,
    libqtermwidget5-0-dev,
    libutf8proc-dev,
    libdtkwidget-dev,
    libdtkgui-dev,
    libkf5networkmanagerqt-dev,
    fbterm,
    kbd,
    libncurses-dev,
    libncursesw5-dev,
    libdeepin-pw-check-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: deepin-installer
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    btrfs-progs,
    deepin-installer-timezones,
    dosfstools,
    imagemagick,
    imageworsener,
    jfsutils,
    mtools,
    ntfs-3g,
    os-prober,
    parted,
    pciutils,
    reiserfsprogs,
    squashfs-tools,
    tshark,
    udev,
    x11-xserver-utils,
    xfsprogs,
    xinit,
    xkb-data,
    deepin-clone,
    cryptsetup,
    lvm2,
    kbd,
    fbterm,
    dde-account-faces,
    dde-qt5integration,
    libdeepin-pw-check,
    deepin-pw-check
Description: Release version of deepin installer
 New version of deepin-installer, rewritten with Qt5.
